package com.example.goldbachv3;

import java.util.ArrayList;

import android.app.Activity;
import android.os.AsyncTask;
import android.os.Bundle;
import android.view.View;
import android.view.View.OnClickListener;
import android.widget.Button;
import android.widget.EditText;
import android.widget.TextView;

public class MainActivity extends Activity {

	private class RealizaAlgoritmo extends AsyncTask<Void, Void, Void> {
		 
		private long start_time, end_time;
		boolean failed = false;

		protected void onPreExecute () {
			
			if (number % 2 != 0) {
				result_text.setText("No es primo");
				failed = true;
			} if (number > 20000000) {
				result_text.setText("Lastima que no hemos sido capaces de tratar números tan grandes. Prueba con un valor inferior o igual a 20000000");
				failed = true;
			} else {
				result_text.setText("Calculando ...");
				calcular.setEnabled(false);
			}
			 
		 }
		 
		 
	     protected Void doInBackground(Void... number) {
	    	 if (!failed) {
		    	 start_time = System.currentTimeMillis();
		    	 Goldbach();
		    	 end_time = System.currentTimeMillis();
	    	 }
	    	 
	    	 return null;
	     }

	     protected void onPostExecute(Void result) {
	    	 
	    	 calcular.setEnabled(true);
	    	 if (!array.isEmpty()) {
		    	 String res = "El algoritmo tarda: " + (end_time - start_time) / 1000.0 + " seg.\n" + 
		    	 "El numero de elementos es de: " +  array.size() + "\n" + 
		    	 "Los sumandos extremos son: " + array.get(0) + " y " + array.get(array.size() -1);
		    	 result_text.setText(res);
	    	 }
	     }
	 }

	private ArrayList<String> array = new ArrayList<String>();
	double mitad;
	private int number;
	private EditText number_text;
	private TextView result_text;
	private Button calcular;
	private int[] primes;
	
	
    public void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_main);
        
        
        number_text = (EditText) findViewById(R.id.editText1);
        result_text = (TextView) findViewById(R.id.textView2);
        calcular = (Button) findViewById(R.id.button1);
        calcular.setOnClickListener(new OnClickListener() {
			
			public void onClick(View v) {
				array.clear();
				if (!number_text.getText().equals("")) {
					number = Integer.valueOf(number_text.getText().toString());
					new RealizaAlgoritmo().execute();
				}
				
			}
		});
        
    }

    
    
    public void Goldbach() {
        
    	//Conseguimos la lista de primos
    	int max_num = number;
    	boolean[] no_primos = new boolean[max_num];
    	no_primos[0] = true;
    	
    	int p = 2;
    	int size = (int) (Math.floor(Math.sqrt(max_num)) + 1);
    	for (int i = 0; i < size; i++) {
    		if (no_primos[p - 1] == false) {
    			for (int j = p + p; j < max_num + 1; j +=p) {
    				no_primos[j - 1] = true; 
    			}
    		}
    		p++;
    	}
    	
    	int p1 = 2;
    	int p2 = no_primos.length;
    	while (p1 <= p2) {
    		if (no_primos[p1 - 1] || p1 + p2 < number) {
    			p1++;
    		} else if (no_primos[p2 - 1] || p1 + p2 > number) {
    			p2--;
    		} else {
    			array.add( p1 + " + " + p2);
    			p1++;
    			p2--;
    		}
    	}
    	
    	
    }
}

   

    

